<!DOCTYPE html>
<html lang="en">
<head>
<meta charset=UTF-8 />
<meta name="viewport" content="width=device-width, initial-scale=1">
<meta name="version" content="4.6"/>
<title>HFS %version%</title>
<style>
a, li span:last-child, small {cursor: pointer; text-decoration: none}
li a[onclick]::before {content:"\1f4c1"}
li>div, aside, header {display: flex; flex-wrap: wrap; justify-content: space-between; font-family:Helvetica; width:100%}
li {display:flex; padding: .3em 0; border-top: 1px solid #ddd}
li span {color:#777}
a[href*="."]::before {content:"\1f4c4  "}
nav a[href*="."]::before {content:""}
a[href$=".mp3"]::before, a[href$=".ogg"]::before {content:"\266a  "}
a[href$=".jpg"]::before {content:"\1f304"}
img+div a[href$=".jpg"]::before {content:""}
a[href$=".mp4"]::before {content:"\1f39e  "} /*1f3ac*/
.checked {background:#f5f5f5}
.check div span:last-child::after {content:" \2610"}
.check .checked span:last-child::after {content:" \2611"}
header {background:#555}
aside {padding: 1.33em 0}
nav {font-weight: bold; background:#cde}
small::after {content:" files\1f552"}
a[onclick]:active {background:#c2c2c2}
/*body {background:#555; color:white}*/ /*dark theme*/
@media (min-width:480px) {header button::after {content:" "attr(id)} #Login>span:empty::after {content:" Login"}}
#Login::after {content:""}
nav a:first-child::before {content:"\2302 Home"} 
.loading {background:#cde}
nav a {color:#000}
li a {-ms-hyphens:auto; -webkit-hyphens:auto; hyphens:auto}
nav a::after {content:"/"} /*" > "*/
/*button:disabled {display:none}*/
</style>
</head>

<body>
<header><button id='upload' onclick="fileElem.click()">&#x21e7;</button><input type="file" id="fileElem" multiple hidden onchange="sendFiles(this.files)">
<button id='Search' onclick="document.querySelector('dialog').showModal()" title="HFS %version%">&#x2315;</button>
<dialog><input type='search' placeholder='search...' name='search'><input type='checkbox' checked title='subf'><button onclick='this.parentNode.close()'><sup>&times;</sup></button></dialog>
<button id='Delete' onclick="del()">X</button>
<button id='Login' onclick="if(this.firstElementChild.textContent) {document.execCommand('ClearAuthenticationCache');location.reload()} else location='/~login'">&#x1f464; <span>%user%</span></button>
<button id='Archive' onclick='del("Archive ")'>&#x21e9;</button>
</header>
<aside><nav></nav><small onclick="get(folder,'&sort=t')"></small></aside>
<main id='files'></main>

<script>
const filemask='index.htm'  //edit here
var folder=location.pathname.match(/.*\//)[0], b

function urlvar(key) {return (location.search.slice(1).match(key+'=(.*)(&|$)')||'')[1]}
function get(val,para){ folder=val; para=para||'';
var xhr = new XMLHttpRequest();
xhr.open("GET", folder+'~files.lst?sort='+(urlvar('sort')||'n')+para);
xhr.onload = function() {var txt=this.response; if(txt.match(filemask)) location=folder; render(m3utojson(txt)); const co=txt.match(/.*$/)[0].slice(1).split(',');upload.disabled=!co[0];Delete.disabled=!co[1]}
xhr.send()
}

get(folder)

function m3utojson(a) {
a=a.split(/\r?\n/);  b=[]
for (var i=1; i<a.length; i+=2) { b.push({url:a[i], modified:a[i-1].split(',')[0].slice(1,-3), size:a[i-1].split(/,0?/)[1]}) }
return b
}

function render(a){
var myTemplate=a.map(function(item) {
 return "<li><div><a "+(item.url.slice(-1)=='/'?"onclick=get('"+folder+item.url+"') href=\'javascript:void(0)\'":"href=\'"+(item.url.match('://')?'':folder)+item.url+"\' target='l'")+">"+decodeURI(item.url).replace(/\/$/,'')+
 "</a><span>"+item.size+"</span><span> "+item.modified+"</span></div></li>"
 })
document.querySelector('main').innerHTML=myTemplate.join('\n')
document.querySelector('nav').innerHTML=bcrumbs(folder); document.querySelector('small').innerHTML=a.length
if(typeof addon=='function') addon()  //
}

function bcrumbs(f) {
var path=f.split('/'), pt='', pr=''
for(pta=0;pta<path.length-1;pta++) {pt+=path[pta]+'/'; pr+='<a href="javascript:void(onclick=get(\''+pt+'\'))">'+(decodeURI(path[pta])||'')+'</a>'}  //+'/'
return pr
}

document.querySelector('input[type=search]').onchange = function(){get(folder,1*this.nextElementSibling.checked? "&search="+this.value:"&files-filter=*"+this.value+"*"); this.parentNode.close()}

var dia=document.querySelector('dialog'); if(!dia.showModal) poly(dia)
function poly(node) {node.showModal=function(){this.hidden=false};  node.close=function(){this.hidden=true};  node.setAttribute('open',''); node.hidden=true}  //mypoly

document.querySelector('main').onclick=function(e){if(e.target.tagName=='SPAN'&&!e.target.nextSibling) e.target.parentNode.classList.toggle("checked")}

</script>
<script>
function sendFiles(filesArray) {
var fd = new FormData()
Array.from(filesArray).forEach(item => fd.append('myFile', item, item.name))
upload.classList.add("loading")
fetch(folder,{method:'POST',body:fd}).then(response => {get(folder); upload.classList.remove("loading")})
}

function del(ar) {
var ref = document.querySelectorAll('.checked'), qstr=''
ref.forEach(item => qstr+='&selection='+(item.firstChild.getAttribute('onclick')?item.firstChild.getAttribute('onclick').slice(5,-2):item.firstChild.getAttribute('href')))
if(!qstr) {document.querySelector('main').classList.toggle("check"); return}
if(!confirm((ar||"Delete ")+ref.length+" file(s) ?")) return
ct={"Content-type":"application/x-www-form-urlencoded"}; 
if(!ar) fetch(folder,{method:'POST',body:"action=delete"+qstr,headers:ct}).then(response => get(folder))
else fetch(folder+"?mode=archive&recursive",{method:'POST',body:qstr,headers:ct}).then(response => response.blob()).then(data =>{a.href=URL.createObjectURL(data);a.click()})
}
var a=document.createElement("a"); a.download='selection.tar'; document.body.appendChild(a)
</script>
</body>
</html>

<!--
[not found]
<h1>Not found</h1><a href="/">&#x2302; Home</a>

[unauthorized]
<h1>Unauthorized</h1>
&#x26d4; wrong username or password

[special:import]
{.if not|{.exists|hfs.filelist.tpl.}|{:{.dialog|Add hfs.filelist.tpl from zip to folder, that contains hfs.exe.}:}.}

-->